        //Javascript Time Picker
        //Displays a digital clock for picking times 
        //Author Clint Mclean               
        //You may use this code anyway you want. 
        //If you find it useful and would like to give something back then you may purchase a product from http://www.brilliantevolver.com
                                
        var timePicker;
           
        function incTimePickerDays(inc)
        {                        
            var elem = document.getElementById("timePickerValue");              
            var days=parseInt(elem.value.substring(0,2), 10);        
            days+=inc;    
            days=days%100;
    
            if (days<0)
                days+=100;        
            if (days<10)    
            {
                days+='';    
                days='0'+days;    
            }
            else
                days+='';    
                    
            document.days1.src='timepicker/timepickerimages/numeral'+days.substring(0,1)+'l.gif';
            document.days2.src='timepicker/timepickerimages/numeral'+days.substring(1,2)+'l.gif';    
        
            elem.value=days + elem.value.substring(2);
        }
                        
        function incTimePickerHours(inc)
        {            
            var hours;
            var elem = document.getElementById("timePickerValue");                          
            if (!this.showDays)
                hours=parseInt(elem.value.substring(0,2), 10);        
            else
                hours=parseInt(elem.value.substring(3,5), 10);            
            
            hours+=inc;    
            hours=hours%24;
    
            if (hours<0)
                hours+=24;        
            if (hours<10)    
            {
                hours+='';    
                hours='0'+hours;    
            }
            else
                hours+='';    
                
            document.timePickerHours1.src='timepicker/timepickerimages/numeral'+hours.substring(0,1)+'l.gif';
            document.timePickerHours2.src='timepicker/timepickerimages/numeral'+hours.substring(1,2)+'l.gif';        
                                    
            if (!this.showDays)                        
                elem.value=hours + elem.value.substring(2);                    
            else
                elem.value=elem.value.substring(0,2) + ":" + hours + elem.value.substring(5);    
        }
        
        function incTimePickerMinutes(inc)
        {            
            var elem = document.getElementById("timePickerValue");              
            var minutes;        
            if (!this.showDays)                        
                minutes=parseInt(elem.value.substring(3,5), 10);            
            else
                minutes=parseInt(elem.value.substring(6,8), 10);            
        
            minutes+=inc;    
            minutes%=60;
    
            if (minutes<0)
                minutes+=60;        
            if (minutes<10)    
            {
                minutes+='';    
                minutes='0'+minutes;    
            }
            else
                minutes+='';    
     
            document.timePickerMinutes1.src='timepicker/timepickerimages/numeral'+minutes.substring(0,1)+'l.gif';
            document.timePickerMinutes2.src='timepicker/timepickerimages/numeral'+minutes.substring(1,2)+'l.gif';
            
            if (!this.showDays)                        
                elem.value=elem.value.substring(0,2) + ":" + minutes + elem.value.substring(5);        
            else
                elem.value=elem.value.substring(0,5) + ":" + minutes + elem.value.substring(8);
        }

        function incTimePickerSeconds(inc)
        {
            var elem = document.getElementById("timePickerValue");              
            var seconds;        
            if (!this.showDays)                        
                seconds=parseInt(elem.value.substring(6,8), 10);        
            else
                seconds=parseInt(elem.value.substring(9,11), 10);        
        
            seconds+=inc;    
            seconds%=60;
        
            if (seconds<0)
                seconds+=60;        
            if (seconds<10)    
            {
                seconds+='';    
                seconds='0'+seconds;    
            }
            else
                seconds+='';    
        
            document.timePickerSeconds1.src='timepicker/timepickerimages/numeral'+seconds.substring(0,1)+'l.gif';
            document.timePickerSeconds2.src='timepicker/timepickerimages/numeral'+seconds.substring(1,2)+'l.gif';
            
            if (!this.showDays)                        
                elem.value=elem.value.substring(0,5) + ":" + seconds;        
            else            
                elem.value=elem.value.substring(0,8) + ":" + seconds;
        }

        
        function timeSelected(timePickerDiv,input)
        {   
            var elemInput = document.getElementById(input);            
            elemInput.value=document.getElementById("timePickerValue").value;                                    
            if (elemInput.onchange)
                elemInput.onchange();            
            document.getElementById(timePickerDiv).style.visibility="hidden";                    
        }
        
        function setTimePickerValue(time)
        {        
            if (time=="")
            {
                var d = new Date();
                var curr_hour = d.getHours();
                var curr_min = d.getMinutes();
                var curr_sec = d.getSeconds();
                        
                if (curr_hour<10)
                    curr_hour="0" + curr_hour;
                
                if (curr_min<10)
                    curr_min="0" + curr_min;
                
                if (curr_sec<10)
                    curr_sec="0" + curr_sec;                            
            
                time = curr_hour + ":" + curr_min + ":" + curr_sec;            
            }
            
            var elem = document.getElementById("timePickerValue");
            elem.value=time;  
            
            if (!this.showDays)
            {                
                document.timePickerHours1.src='timepicker/timepickerimages/numeral'+time.substring(0,1)+'l.gif';
                document.timePickerHours2.src='timepicker/timepickerimages/numeral'+time.substring(1,2)+'l.gif';
                document.timePickerMinutes1.src='timepicker/timepickerimages/numeral'+time.substring(3,4)+'l.gif';
                document.timePickerMinutes2.src='timepicker/timepickerimages/numeral'+time.substring(4,5)+'l.gif';
                document.timePickerSeconds1.src='timepicker/timepickerimages/numeral'+time.substring(6,7)+'l.gif';
                document.timePickerSeconds2.src='timepicker/timepickerimages/numeral'+time.substring(7,8)+'l.gif';    
            }
            else
            {                
                document.days1.src='timepicker/timepickerimages/numeral'+time.substring(0,1)+'l.gif';
                document.days2.src='timepicker/timepickerimages/numeral'+time.substring(1,2)+'l.gif';
                document.timePickerHours1.src='timepicker/timepickerimages/numeral'+time.substring(3,4)+'l.gif';
                document.timePickerHours2.src='timepicker/timepickerimages/numeral'+time.substring(4,5)+'l.gif';
                document.timePickerMinutes1.src='timepicker/timepickerimages/numeral'+time.substring(6,7)+'l.gif';
                document.timePickerMinutes2.src='timepicker/timepickerimages/numeral'+time.substring(7,8)+'l.gif';
                document.timePickerSeconds1.src='timepicker/timepickerimages/numeral'+time.substring(9,10)+'l.gif';
                document.timePickerSeconds2.src='timepicker/timepickerimages/numeral'+time.substring(10,11)+'l.gif';                
            }
        }
        
     function position(div, e, xShift, yShift, visible) 
    { 
        var posx = 0; 
        var posy = 0; 
        var obj = document.getElementById(div); 
        if (!e) var e = window.event; 
        if (e.pageX || e.pageY) 
        { 
            posx = e.pageX; 
            posy = e.pageY;
        } 
        else if (e.clientX || e.clientY) 
        { 
            posx = e.clientX + document.documentElement.scrollLeft; 
            posy = e.clientY + document.documentElement.scrollTop; 
        }        
                
        obj.style.top=(posy+yShift) + 'px'; 
        obj.style.left=(posx+xShift) + 'px';                         
        
        if (visible)
            obj.style.visibility='visible'; 
        else
            obj.style.visibility='hidden'; 
        obj.style.position='absolute';         
    } 
        
        function showTimePicker(timePickerDiv,input,time,anchor,showDays)
        {
            var elem = document.getElementById(timePickerDiv);          
            elem.style.visibility="visible";                    
           
            if (!showDays)              
                elem.innerHTML='<input id="timePickerValue" name="timePicker" type="hidden" value=""/><img src="timepicker/timepickerimages/numeral8l.gif" name="timePickerHours1"><img src="timepicker/timepickerimages/numeral8l.gif" name="timePickerHours2"><img src="timepicker/timepickerimages/numeralc3l.gif" usemap="#incHl" style="border:none"><img src="timepicker/timepickerimages/numeral8l.gif" name="timePickerMinutes1"><img src="timepicker/timepickerimages/numeral8l.gif" name="timePickerMinutes2"><img src="timepicker/timepickerimages/numeralc3l.gif" usemap="#incMl" style="border:none"><img src="timepicker/timepickerimages/numeral8l.gif" name="timePickerSeconds1"><img src="timepicker/timepickerimages/numeral8l.gif" name="timePickerSeconds2"><img src="timepicker/timepickerimages/numeralc3l.gif" usemap="#incSl"  style="border:none"><map name="incHl"><area alt="Click arrows to change values" shape="rect" coords="0,0,11,9" onclick="timePicker.incTimePickerHours(1);"><area alt="Click arrows to change values" shape="rect" coords="0,5,11,19" onclick="timePicker.incTimePickerHours(10);"><area alt="Click arrows to change values" shape="rect" coords="0,28,11,38" onclick="timePicker.incTimePickerHours(-10);"><area alt="Click arrows to change values" shape="rect" coords="0,38,11,48" onclick="timePicker.incTimePickerHours(-1);"></map><map name="incMl"><area alt="Click arrows to change values" shape="rect" coords="0,0,11,9" onclick="timePicker.incTimePickerMinutes(1);"><area alt="Click arrows to change values" shape="rect" coords="0,5,11,19" onclick="timePicker.incTimePickerMinutes(10);"><area alt="Click arrows to change values" shape="rect" coords="0,28,11,38" onclick="timePicker.incTimePickerMinutes(-10);"><area alt="Click arrows to change values" shape="rect" coords="0,38,11,48" onclick="timePicker.incTimePickerMinutes(-1);"></map><map name="incSl"><area alt="Click arrows to change values" shape="rect" coords="0,0,11,9" onclick="timePicker.incTimePickerSeconds(1);"><area alt="Click arrows to change values" shape="rect" coords="0,5,11,19" onclick="timePicker.incTimePickerSeconds(10);"><area alt="Click arrows to change values" shape="rect" coords="0,28,11,38" onclick="timePicker.incTimePickerSeconds(-10);"><area alt="Click arrows to change values" shape="rect" coords="0,38,11,48" onclick="timePicker.incTimePickerSeconds(-1);"></map>&nbsp&nbsp<button onclick="timeSelected(\''+timePickerDiv+'\',\''+input+'\');">Done</button>';                        
            else
                elem.innerHTML='<input id="timePickerValue" name="timePicker" type="hidden" value=""/><img alt="Click arrows to change values" src="timepicker/timepickerimages/numeral8l.gif" name="days1"><img alt="Click arrows to change values" src="timepicker/timepickerimages/numeral8l.gif" name="days2"><img alt="Click arrows to change values" src="timepicker/timepickerimages/numeralc3l.gif" usemap="#incDl" style="border:none"><img src="timepicker/timepickerimages/numeral8l.gif" name="timePickerHours1"><img src="timepicker/timepickerimages/numeral8l.gif" name="timePickerHours2"><img src="timepicker/timepickerimages/numeralc3l.gif" usemap="#incHl" style="border:none"><img src="timepicker/timepickerimages/numeral8l.gif" name="timePickerMinutes1"><img src="timepicker/timepickerimages/numeral8l.gif" name="timePickerMinutes2"><img src="timepicker/timepickerimages/numeralc3l.gif" usemap="#incMl" style="border:none"><img src="timepicker/timepickerimages/numeral8l.gif" name="timePickerSeconds1"><img src="timepicker/timepickerimages/numeral8l.gif" name="timePickerSeconds2"><img src="timepicker/timepickerimages/numeralc3l.gif" usemap="#incSl" style="border:none"><map name="incDl"><area alt="Click arrows to change values" shape="rect" coords="0,0,11,9" onclick="timePicker.incTimePickerDays(1);"><area alt="Click arrows to change values" shape="rect" coords="0,5,11,19" onclick="timePicker.incTimePickerDays(10);"><area alt="Click arrows to change values" shape="rect" coords="0,28,11,38" onclick="timePicker.incTimePickerDays(-10);"><area alt="Click arrows to change values" shape="rect" coords="0,38,11,48" onclick="timePicker.incTimePickerDays(-1);"></map><map name="incHl"><area alt="Click arrows to change values" shape="rect" coords="0,0,11,9" onclick="timePicker.incTimePickerHours(1);"><area alt="Click arrows to change values" shape="rect" coords="0,5,11,19" onclick="timePicker.incTimePickerHours(10);"><area alt="Click arrows to change values" shape="rect" coords="0,28,11,38" onclick="timePicker.incTimePickerHours(-10);"><area alt="Click arrows to change values" shape="rect" coords="0,38,11,48" onclick="timePicker.incTimePickerHours(-1);"></map><map name="incMl"><area alt="Click arrows to change values" shape="rect" coords="0,0,11,9" onclick="timePicker.incTimePickerMinutes(1);"><area alt="Click arrows to change values" shape="rect" coords="0,5,11,19" onclick="timePicker.incTimePickerMinutes(10);"><area alt="Click arrows to change values" shape="rect" coords="0,28,11,38" onclick="timePicker.incTimePickerMinutes(-10);"><area alt="Click arrows to change values" shape="rect" coords="0,38,11,48" onclick="timePicker.incTimePickerMinutes(-1);"></map><map name="incSl"><area alt="Click arrows to change values" shape="rect" coords="0,0,11,9" onclick="timePicker.incTimePickerSeconds(1);"><area alt="Click arrows to change values" shape="rect" coords="0,5,11,19" onclick="timePicker.incTimePickerSeconds(10);"><area alt="Click arrows to change values" shape="rect" coords="0,28,11,38" onclick="timePicker.incTimePickerSeconds(-10);"><area alt="Click arrows to change values" shape="rect" coords="0,38,11,48" onclick="timePicker.incTimePickerSeconds(-1);"></map>&nbsp&nbsp<button onclick="timeSelected(\''+timePickerDiv+'\',\''+input+'\');">Done</button>';                        
                        
                this.setTimePickerValue(time);                        
        }
        
        function TimePicker(timePickerDiv,inputTime,value,anchor,showDays)
        {
            this.timePickerDiv=timePickerDiv;
            this.inputTime=inputTime;
            this.showTimePicker = showTimePicker;
            this.setTimePickerValue = setTimePickerValue;
            this.timeSelected = timeSelected;            
            this.anchor=anchor;
            this.incTimePickerDays=incTimePickerDays;
            this.incTimePickerHours=incTimePickerHours;
            this.incTimePickerMinutes=incTimePickerMinutes;
            this.incTimePickerSeconds=incTimePickerSeconds;
            this.showDays=showDays;
                        
            this.showTimePicker(timePickerDiv,inputTime,value,anchor,showDays);
        }             
                        
        //This is the function that you use on your page to show the time picker
        //timePickerDiv is the name of the div that contains the time picker
        //e is the mouse click event that contains the coordinates for placing the time picker
        //inputName is the name of the input field where the time is placed
        //showDays indicates whether we want to show days. You may want to show days when selecting a duration
        function showTimePickerWithPlacement(timePickerDiv,e,inputName,showDays)
        {                       
            position(timePickerDiv, e, -100, -50, true);                    
            var elem = document.getElementById(inputName);                        
            timePicker = new TimePicker(timePickerDiv,inputName,elem.value,inputName,showDays);                        
        }        
